LINUX.ORG.RU

sshd запустить одновременно на двух портах

 , , ,


0

1

Есть необходимость запустить сразу два демона sshd на разных портах - 22 и 2022.

Система Ubuntu 20.04.1 LTS SSH-2.0-OpenSSH_8.2p1

Нашел что то похожее в интернете, только там на Fedora делают

https://sys-adm.in/os/nix/801-ssh-na-neskolkikh-portakh-neskolko-servisov-ssh...

Скопировал файл sshd с другим именем (sshd_2) , в ту же директорию, где и изначальный sshd находится - /usr/sbin/sshd_2

Скопировал текущий конфиг для 22 порта, поменял порт на 2022:

/etc/ssh/sshd_config_2

Port 2022
#ListenAddress ::
#ListenAddress 0.0.0.0
Protocol 2
HostKey /etc/ssh/ssh_host_rsa_key
HostKey /etc/ssh/ssh_host_dsa_key
HostKey /etc/ssh/ssh_host_ecdsa_key
HostKey /etc/ssh/ssh_host_ed25519_key
SyslogFacility AUTH
LogLevel INFO
LoginGraceTime 120
PermitRootLogin prohibit-password
StrictModes yes
PubkeyAuthentication yes
#AuthorizedKeysFile	%h/.ssh/authorized_keys
IgnoreRhosts yes
HostbasedAuthentication no
#IgnoreUserKnownHosts yes
PermitEmptyPasswords no
ChallengeResponseAuthentication no
PasswordAuthentication no
X11Forwarding yes
X11DisplayOffset 10
PrintMotd yes
PrintLastLog yes
TCPKeepAlive yes
#UseLogin no
#MaxStartups 10:30:60
#Banner /etc/issue.net
AcceptEnv LANG LC_*
Subsystem sftp /usr/lib/openssh/sftp-server
UsePAM yes
ClientAliveInterval 60
UseDNS no

Запускаю sshd c указанием конфиг файла: /usr/sbin/sshd_2 -f /etc/ssh/sshd_config_2

Все нормально запускается, без вопросов ss -tulpn | grep sshd

tcp   LISTEN 0      128                         0.0.0.0:22         0.0.0.0:*     users:(("sshd",pid=1088,fd=3))                                                 
tcp   LISTEN 0      128                         0.0.0.0:2022       0.0.0.0:*     users:(("sshd_2",pid=30731,fd=3))                                              
tcp   LISTEN 0      128                            [::]:22            [::]:*     users:(("sshd",pid=1088,fd=4))                                                 
tcp   LISTEN 0      128                            [::]:2022          [::]:*     users:(("sshd_2",pid=30731,fd=4))

Скопировал файл запуска демона с новым именем ssh_2. Вроде бы везде где нужно заменил sshd на sshd_2 . Еще добавил передачу параметра с конфиг файлом SSHD_2_OPTS="-f /etc/ssh/sshd_config_2" . Как его по другому заставить читать файл с конфигом, не придумал.

/etc/init.d/ssh_2

#! /bin/sh

### BEGIN INIT INFO
# Provides:		sshd_2
# Required-Start:	$remote_fs $syslog
# Required-Stop:	$remote_fs $syslog
# Default-Start:	2 3 4 5
# Default-Stop:		
# Short-Description:	OpenBSD Secure Shell server
### END INIT INFO

set -e

# /etc/init.d/ssh: start and stop the OpenBSD "secure shell(tm)" daemon

test -x /usr/sbin/sshd_2 || exit 0
( /usr/sbin/sshd_2 -\? 2>&1 | grep -q OpenSSH ) 2>/dev/null || exit 0

umask 022

if test -f /etc/default/ssh_2; then
    . /etc/default/ssh_2
fi

. /lib/lsb/init-functions

if [ -n "$2" ]; then
    SSHD_2_OPTS="$SSHD_2_OPTS $2"
fi

SSHD_2_OPTS="-f /etc/ssh/sshd_config_2"

# Are we running from init?
run_by_init() {
    ([ "$previous" ] && [ "$runlevel" ]) || [ "$runlevel" = S ]
}

check_for_no_start() {
    # forget it if we're trying to start, and /etc/ssh/sshd_2_not_to_be_run exists
    if [ -e /etc/ssh/sshd_2_not_to_be_run ]; then 
	if [ "$1" = log_end_msg ]; then
	    log_end_msg 0 || true
	fi
	if ! run_by_init; then
	    log_action_msg "OpenBSD Secure Shell server not in use (/etc/ssh/sshd_2_not_to_be_run)" || true
	fi
	exit 0
    fi
}

check_dev_null() {
    if [ ! -c /dev/null ]; then
	if [ "$1" = log_end_msg ]; then
	    log_end_msg 1 || true
	fi
	if ! run_by_init; then
	    log_action_msg "/dev/null is not a character device!" || true
	fi
	exit 1
    fi
}

check_privsep_dir() {
    # Create the PrivSep empty dir if necessary
    if [ ! -d /run/sshd_2 ]; then
	mkdir /run/sshd_2
	chmod 0755 /run/sshd_2
    fi
}

check_config() {
    if [ ! -e /etc/ssh/sshd_2_not_to_be_run ]; then
	/usr/sbin/sshd_2 $SSHD_2_OPTS -t || exit 1
    fi
}

export PATH="${PATH:+$PATH:}/usr/sbin:/sbin"

case "$1" in
  start)
	check_privsep_dir
	check_for_no_start
	check_dev_null
	log_daemon_msg "Starting OpenBSD Secure Shell server" "sshd_2" || true
	if start-stop-daemon --start --quiet --oknodo --chuid 0:0 --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2 -- $SSHD_2_OPTS; then
	    log_end_msg 0 || true
	else
	    log_end_msg 1 || true
	fi
	;;
  stop)
	log_daemon_msg "Stopping OpenBSD Secure Shell server" "sshd_2" || true
	if start-stop-daemon --stop --quiet --oknodo --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2; then
	    log_end_msg 0 || true
	else
	    log_end_msg 1 || true
	fi
	;;

  reload|force-reload)
	check_for_no_start
	check_config
	log_daemon_msg "Reloading OpenBSD Secure Shell server's configuration" "sshd_2" || true
	if start-stop-daemon --stop --signal 1 --quiet --oknodo --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2; then
	    log_end_msg 0 || true
	else
	    log_end_msg 1 || true
	fi
	;;

  restart)
	check_privsep_dir
	check_config
	log_daemon_msg "Restarting OpenBSD Secure Shell server" "sshd_2" || true
	start-stop-daemon --stop --quiet --oknodo --retry 30 --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2
	check_for_no_start log_end_msg
	check_dev_null log_end_msg
	if start-stop-daemon --start --quiet --oknodo --chuid 0:0 --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2 -- $SSHD_2_OPTS; then
	    log_end_msg 0 || true
	else
	    log_end_msg 1 || true
	fi
	;;

  try-restart)
	check_privsep_dir
	check_config
	log_daemon_msg "Restarting OpenBSD Secure Shell server" "sshd_2" || true
	RET=0
	start-stop-daemon --stop --quiet --retry 30 --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2 || RET="$?"
	case $RET in
	    0)
		# old daemon stopped
		check_for_no_start log_end_msg
		check_dev_null log_end_msg
		if start-stop-daemon --start --quiet --oknodo --chuid 0:0 --pidfile /run/sshd_2.pid --exec /usr/sbin/sshd_2 -- $SSHD_2_OPTS; then
		    log_end_msg 0 || true
		else
		    log_end_msg 1 || true
		fi
		;;
	    1)
		# daemon not running
		log_progress_msg "(not running)" || true
		log_end_msg 0 || true
		;;
	    *)
		# failed to stop
		log_progress_msg "(failed to stop)" || true
		log_end_msg 1 || true
		;;
	esac
	;;

  status)
	status_of_proc -p /run/sshd_2.pid /usr/sbin/sshd_2 sshd_2 && exit 0 || exit $?
	;;

  *)
	log_action_msg "Usage: /etc/init.d/ssh {start|stop|reload|force-reload|restart|try-restart|status}" || true
	exit 1
esac

exit 0

Скопировал файл параметров демона. По идее через этот файл надо было бы предавать параметр с конфиг файлом, но что то никак не получается, поэтому он такой же как оригинальный

/etc/default/ssh_2

# Default settings for openssh-server. This file is sourced by /bin/sh from
# /etc/init.d/ssh.

# Options to pass to sshd
SSHD_OPTS_2=

Пробую запустить демон /etc/init.d/ssh_2 start

стартует, все ок.

Пробую остановить, /etc/init.d/ssh_2 stop

Не останавливается. Висит по прежнему на том же порту 2022. Подключиться можно к обоим sshd.

ss -tulpn | grep sshd

tcp   LISTEN 0      128                         0.0.0.0:22         0.0.0.0:*     users:(("sshd",pid=1088,fd=3))                                                 
tcp   LISTEN 0      128                         0.0.0.0:2022       0.0.0.0:*     users:(("sshd_2",pid=30731,fd=3))                                              
tcp   LISTEN 0      128                            [::]:22            [::]:*     users:(("sshd",pid=1088,fd=4))                                                 
tcp   LISTEN 0      128                            [::]:2022          [::]:*     users:(("sshd_2",pid=30731,fd=4))

Если же остановить основной сервис sshd, то подключиться к ssh_2 (2022 порт ) не получается ( ну и к 22 порту тоже, что вроде бы логично, я же его остановил)

/etc/init.d/ssh stop

ошибка : ssh san@localhost -p 2022

kex_exchange_identification: read: Connection reset by peer

Хотя порт 2022 открыт

ss -tulpn | grep sshd

tcp   LISTEN 0      128                         0.0.0.0:2022       0.0.0.0:*     users:(("sshd_2",p
id=1590,fd=3))                                               
tcp   LISTEN 0      128                            [::]:2022          [::]:*     users:(("sshd_2",p
id=1590,fd=4))            

В чем ошибка, почему не работают нормально два демона sshd ?



Последнее исправление: SANyaSmol (всего исправлений: 5)

А тебе действительно надо именно два демона или достаточно, чтобы к одному демону можно было подцепиться на разных портах?

frob ★★★★★
()

PidFile то кто в конфиге будет указывать?

И зачем вам SSHD_OPTS_2, если вы его не используете?

mky ★★★★★
()
Ответ на: комментарий от SANyaSmol

Добавь правило перенаправления с порта 2022 на порт 22.

Есть правило - отвечает с двух портов.

Удалил правило - отвечает только с 22.

anonymous
()
Ответ на: комментарий от mky

PidFile то кто в конфиге будет указывать?

Да, все просто оказалось))). Теперь все работает как и нужно!! Спасибо за подсказку"!

cat sshd_config_2

[code] Port 2022 PidFile /run/sshd_2.pid #ListenAddress :: #ListenAddress 0.0.0.0 Protocol 2 HostKey /etc/ssh/ssh_host_rsa_key HostKey /etc/ssh/ssh_host_dsa_key HostKey /etc/ssh/ssh_host_ecdsa_key HostKey /etc/ssh/ssh_host_ed25519_key SyslogFacility AUTH LogLevel INFO LoginGraceTime 120 PermitRootLogin prohibit-password StrictModes yes PubkeyAuthentication yes #AuthorizedKeysFile %h/.ssh/authorized_keys IgnoreRhosts yes HostbasedAuthentication no #IgnoreUserKnownHosts yes PermitEmptyPasswords no ChallengeResponseAuthentication no PasswordAuthentication no X11Forwarding yes X11DisplayOffset 10 PrintMotd yes PrintLastLog yes TCPKeepAlive yes #UseLogin no #MaxStartups 10:30:60 #Banner /etc/issue.net AcceptEnv LANG LC_* Subsystem sftp /usr/lib/openssh/sftp-server UsePAM yes ClientAliveInterval 60 UseDNS no [/code]

зачем вам SSHD_OPTS_2, если вы его не используете?

Я в нее пишу «-f /etc/ssh/sshd_config_2». По другому не придумал как передать конфиг в демон

SANyaSmol
() автор топика
Последнее исправление: SANyaSmol (всего исправлений: 1)
Ответ на: комментарий от SANyaSmol

Нет, вы пишите:

SSHD_2_OPTS="-f /etc/ssh/sshd_config_2"

а в файле /etc/default/ssh_2 у вас SSHD_OPTS_2.

mky ★★★★★
()

Ошибкой было создавать скрипты для init.d. Тк в ubuntu используется systemd. Соотвественно демон из etc/init.d/ не запускается при старте системы. Поэтому дальше пробую в systemd.

Создал копии сервис-файла сокет-файла оригиральных sshd в /lib/systemd/system. С изменением sshd на sshd_2 где нужно. ssh_2@.service и ssh_2.socket скорее всего не нужны для запуска демона, но пусть будут..

/lib/systemd/system/ssh_2.service

[code] [Unit] Description=OpenBSD Secure Shell server _2 Documentation=man:sshd(8) man:sshd_config(5) After=network.target auditd.service ConditionPathExists=!/etc/ssh/sshd_2_not_to_be_run

[Service] PIDFile=/var/run/sshd_2.pid EnvironmentFile=-/etc/default/ssh_2 ExecStartPre=/usr/sbin/sshd_2 -t ExecStart=/usr/sbin/sshd_2 -D $SSHD_2_OPTS ExecReload=/usr/sbin/sshd_2 -t ExecReload=/bin/kill -HUP $MAINPID KillMode=process Restart=on-failure RestartPreventExitStatus=255 Type=notify RuntimeDirectory=sshd_2 RuntimeDirectoryMode=0755

[Install] WantedBy=multi-user.target Alias=sshd_2.service root@san-vps:/lib/systemd/system# [/code]

/lib/systemd/system/ssh_2.socket

[code] [Unit] Description=OpenBSD Secure Shell server _2 socket Before=ssh_2.service Conflicts=ssh_2.service ConditionPathExists=!/etc/ssh/sshd_2_not_to_be_run

[Socket] ListenStream=2022 Accept=yes

[Install] WantedBy=sockets.target [/code]

/lib/systemd/system/ssh_2@.service

[code] [Unit] Description=OpenBSD Secure Shell server _2 per-connection daemon Documentation=man:sshd(8) man:sshd_config(5) After=auditd.service

[Service] EnvironmentFile=-/etc/default/ssh_2 ExecStart=-/usr/sbin/sshd_2 -i $SSHD_2_OPTS StandardInput=socket RuntimeDirectory=sshd_2 RuntimeDirectoryMode=0755 [/code]

Копия настроек для ssh

/etc/default/ssh_2

[code]

Default settings for openssh-server. This file is sourced by /bin/sh from

/etc/init.d/ssh.

Options to pass to sshd

SSHD_2_OPTS=’ -f /etc/ssh/sshd_config_2’ [/code]

конфиг файл sshd

/etc/ssh/sshd_config_2

[code] Port 2022 PidFile /run/sshd_2.pid #ListenAddress :: #ListenAddress 0.0.0.0 Protocol 2 HostKey /etc/ssh/ssh_host_rsa_key HostKey /etc/ssh/ssh_host_dsa_key HostKey /etc/ssh/ssh_host_ecdsa_key HostKey /etc/ssh/ssh_host_ed25519_key SyslogFacility AUTH LogLevel INFO LoginGraceTime 120 PermitRootLogin prohibit-password StrictModes yes PubkeyAuthentication yes #AuthorizedKeysFile %h/.ssh/authorized_keys IgnoreRhosts yes HostbasedAuthentication no #IgnoreUserKnownHosts yes PermitEmptyPasswords no ChallengeResponseAuthentication no PasswordAuthentication no X11Forwarding yes X11DisplayOffset 10 PrintMotd yes PrintLastLog yes TCPKeepAlive yes #UseLogin no #MaxStartups 10:30:60 #Banner /etc/issue.net AcceptEnv LANG LC_* Subsystem sftp /usr/lib/openssh/sftp-server UsePAM yes ClientAliveInterval 60 UseDNS no [/code]

SANyaSmol
() автор топика
Ответ на: комментарий от SANyaSmol

Копия настроек аутентификации - без изменений

/etc/pam.d/sshd_2

# PAM configuration for the Secure Shell service

# Standard Un*x authentication.
@include common-auth

# Disallow non-root logins when /etc/nologin exists.
account    required     pam_nologin.so

# Uncomment and edit /etc/security/access.conf if you need to set complex
# access limits that are hard to express in sshd_config.
# account  required     pam_access.so

# Standard Un*x authorization.
@include common-account

# SELinux needs to be the first session rule.  This ensures that any
# lingering context has been cleared.  Without this it is possible that a
# module could execute code in the wrong domain.
session [success=ok ignore=ignore module_unknown=ignore default=bad]        pam_selinux.so close

# Set the loginuid process attribute.
session    required     pam_loginuid.so

# Create a new session keyring.
session    optional     pam_keyinit.so force revoke

# Standard Un*x session setup and teardown.
@include common-session

# Print the message of the day upon successful login.
# This includes a dynamically generated part from /run/motd.dynamic
# and a static (admin-editable) part from /etc/motd.
session    optional     pam_motd.so  motd=/run/motd.dynamic
session    optional     pam_motd.so noupdate

# Print the status of the user's mailbox upon successful login.
session    optional     pam_mail.so standard noenv # [1]

# Set up user limits from /etc/security/limits.conf.
session    required     pam_limits.so

# Read environment variables from /etc/environment and
# /etc/security/pam_env.conf.
session    required     pam_env.so # [1]
# In Debian 4.0 (etch), locale-related environment variables were moved to
# /etc/default/locale, so read that as well.
session    required     pam_env.so user_readenv=1 envfile=/etc/default/locale

# SELinux needs to intervene at login time to ensure that the process starts
# in the proper default security context.  Only sessions which are intended
# to run in the user's context should be run after this.
session [success=ok ignore=ignore module_unknown=ignore default=bad]        pam_selinux.so open

# Standard Un*x password updating.
@include common-password

Вроде все файлы, которые добавил. Дальше стандартно systemctl daemon-reload перезагрузили файлы systemctl enable ssh_2 разрешили демон для автозапуска

Теперь проблемы ((( Если остановить ssh_2 - systemctl stop ssh_2 все как и должно быть. ssh_2 останавливается, ssh продолжает работать. К 22 порту подключиться можно, к 2022 нельзя

systemctl status ssh

● ssh.service - OpenBSD Secure Shell server
     Loaded: loaded (/lib/systemd/system/ssh.service; enabled; vendor preset: enabled)
     Active: active (running) since Wed 2021-01-13 13:15:36 MSK; 8h ago
       Docs: man:sshd(8)
             man:sshd_config(5)
    Process: 1034 ExecStartPre=/usr/sbin/sshd -t (code=exited, status=0/SUCCESS)
   Main PID: 1074 (sshd)
      Tasks: 1 (limit: 655)
     Memory: 5.0M
     CGroup: /system.slice/ssh.service
             └─1074 sshd: /usr/sbin/sshd -D [listener] 0 of 10-100 startups

systemctl status ssh_2

● ssh_2.service - OpenBSD Secure Shell server _2
     Loaded: loaded (/lib/systemd/system/ssh_2.service; enabled; vendor preset: enabled)
     Active: inactive (dead) since Wed 2021-01-13 22:00:46 MSK; 2min 24s ago
       Docs: man:sshd(8)
             man:sshd_config(5)
    Process: 1035 ExecStartPre=/usr/sbin/sshd_2 -t (code=exited, status=0/SUCCESS)
    Process: 1075 ExecStart=/usr/sbin/sshd_2 -D $SSHD_2_OPTS (code=exited, status=0/SUCCESS)
   Main PID: 1075 (code=exited, status=0/SUCCESS)

ps -A | grep sshd

   1074 ?        00:00:00 sshd
  11712 ?        00:00:00 sshd
  11786 ?        00:00:00 sshd

Если же остановить ssh, systemctl stop ssh то после этого нельзя подключиться к серверу до перезагрузки, что там происходит, посмотреть не могу. Вот вывод статусов до откючения от ssh

systemctl status ssh

● ssh.service - OpenBSD Secure Shell server
     Loaded: loaded (/lib/systemd/system/ssh.service; enabled; vendor preset: enabled)
     Active: inactive (dead) since Wed 2021-01-13 22:08:49 MSK; 10s ago
       Docs: man:sshd(8)
             man:sshd_config(5)
    Process: 1034 ExecStartPre=/usr/sbin/sshd -t (code=exited, status=0/SUCCESS)
    Process: 1074 ExecStart=/usr/sbin/sshd -D $SSHD_OPTS (code=exited, status=0/SUCCESS)
   Main PID: 1074 (code=exited, status=0/SUCCESS)

Jan 13 22:08:49  systemd[1]: Stopping OpenBSD Secure Shell server...
Jan 13 22:08:49  sshd[1074]: Received signal 15; terminating.
Jan 13 22:08:49  systemd[1]: ssh.service: Succeeded.
Jan 13 22:08:49  systemd[1]: Stopped OpenBSD Secure Shell server.

systemctl status ssh_2

● ssh_2.service - OpenBSD Secure Shell server _2
     Loaded: loaded (/lib/systemd/system/ssh_2.service; enabled; vendor preset: enabled)
     Active: active (running) since Wed 2021-01-13 22:08:41 MSK; 2min 12s ago
       Docs: man:sshd(8)
             man:sshd_config(5)
    Process: 11972 ExecStartPre=/usr/sbin/sshd_2 -t (code=exited, status=0/SUCCESS)
   Main PID: 11983 (sshd_2)
      Tasks: 1 (limit: 655)
     Memory: 1.2M
     CGroup: /system.slice/ssh_2.service
             └─11983 sshd_2: /usr/sbin/sshd_2 -D -f /etc/ssh/sshd_config_2 [listener] 0 of 10-100 >

ps -A | grep sshd в выводе есть sshd, потому что я сижу по ssh на сервере

  11712 ?        00:00:00 sshd
  11786 ?        00:00:00 sshd
  11983 ?        00:00:00 sshd_2

Все, после отключения нельзя больше подключиться ни к 22 ни к 2022 порту... ssh san@123.123.123.123 -p 2022 sh: connect to host 123.123.123.123 port 22: Connection refused

ssh sss@123.123.123.123 -p 2022 kex_exchange_identification: read: Connection reset by peer

SANyaSmol
() автор топика
Ответ на: комментарий от deep-purple

cat /etc/ssh/sshd_config_2 |grep «Port|port»

Port 2022

?? или где? в каком конфиге?

SANyaSmol
() автор топика
Последнее исправление: SANyaSmol (всего исправлений: 1)
edit /etc/ssh/sshd_config
/etc/init.d/sshd reload
systemctl reload sshd
why
()
Последнее исправление: why (всего исправлений: 3)
Ответ на: комментарий от targitaj

Тьыу, все,. понял что вы мне пишете.

Это не то. Мне нужно два экземпляра сервиса. Чтобы любой экземпляр можно было остановить - запустить по необходимости. А с двумя портами в конфиге так не получится, если только комментить ненужный порт и перезапускать.

SANyaSmol
() автор топика
Ответ на: комментарий от SANyaSmol

Нужно три. Чтобы два остановил, третий работает.

evgeny_aa ★★☆
()
Вы не можете добавлять комментарии в эту тему. Тема перемещена в архив.